<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>NettyServerCnxn.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">NettyServerCnxn.java</span></div><h1>NettyServerCnxn.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import static org.jboss.netty.buffer.ChannelBuffers.wrappedBuffer;

import java.io.BufferedWriter;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Writer;
import java.net.InetSocketAddress;
import java.net.SocketAddress;
import java.nio.ByteBuffer;
import java.util.AbstractSet;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.concurrent.atomic.AtomicLong;

import org.apache.jute.BinaryInputArchive;
import org.apache.jute.BinaryOutputArchive;
import org.apache.jute.Record;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.Environment;
import org.apache.zookeeper.Version;
import org.apache.zookeeper.WatchedEvent;
import org.apache.zookeeper.proto.ReplyHeader;
import org.apache.zookeeper.proto.WatcherEvent;
import org.apache.zookeeper.server.quorum.Leader;
import org.apache.zookeeper.server.quorum.LeaderZooKeeperServer;
import org.apache.zookeeper.server.quorum.ReadOnlyZooKeeperServer;
import org.apache.zookeeper.server.util.OSMXBean;
import org.jboss.netty.buffer.ChannelBuffer;
import org.jboss.netty.buffer.ChannelBuffers;
import org.jboss.netty.channel.Channel;
import org.jboss.netty.channel.ChannelFuture;
import org.jboss.netty.channel.MessageEvent;

public class NettyServerCnxn extends ServerCnxn {
<span class="fc" id="L58">    Logger LOG = LoggerFactory.getLogger(NettyServerCnxn.class);</span>
    Channel channel;
    ChannelBuffer queuedBuffer;
    volatile boolean throttled;
    ByteBuffer bb;
<span class="fc" id="L63">    ByteBuffer bbLen = ByteBuffer.allocate(4);</span>
    long sessionId;
    int sessionTimeout;
<span class="fc" id="L66">    AtomicLong outstandingCount = new AtomicLong();</span>

    /** The ZooKeeperServer for this connection. May be null if the server
     * is not currently serving requests (for example if the server is not
     * an active quorum participant.
     */
    private volatile ZooKeeperServer zkServer;

    NettyServerCnxnFactory factory;
    boolean initialized;
    
<span class="fc" id="L77">    NettyServerCnxn(Channel channel, ZooKeeperServer zks, NettyServerCnxnFactory factory) {</span>
<span class="fc" id="L78">        this.channel = channel;</span>
<span class="fc" id="L79">        this.zkServer = zks;</span>
<span class="fc" id="L80">        this.factory = factory;</span>
<span class="pc bpc" id="L81" title="1 of 2 branches missed.">        if (this.factory.login != null) {</span>
<span class="nc" id="L82">            this.zooKeeperSaslServer = new ZooKeeperSaslServer(factory.login);</span>
        }
<span class="fc" id="L84">    }</span>
    
    @Override
    public void close() {
<span class="pc bpc" id="L88" title="1 of 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L89">            LOG.debug(&quot;close called for sessionid:0x&quot;</span>
<span class="nc" id="L90">                    + Long.toHexString(sessionId));</span>
        }
<span class="fc" id="L92">        synchronized(factory.cnxns){</span>
            // if this is not in cnxns then it's already closed
<span class="fc bfc" id="L94" title="All 2 branches covered.">            if (!factory.cnxns.remove(this)) {</span>
<span class="pc bpc" id="L95" title="1 of 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L96">                    LOG.debug(&quot;cnxns size:&quot; + factory.cnxns.size());</span>
                }
<span class="fc" id="L98">                return;</span>
            }
<span class="pc bpc" id="L100" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L101">                LOG.debug(&quot;close in progress for sessionid:0x&quot;</span>
<span class="nc" id="L102">                        + Long.toHexString(sessionId));</span>
            }

<span class="fc" id="L105">            synchronized (factory.ipMap) {</span>
<span class="fc" id="L106">                Set&lt;NettyServerCnxn&gt; s =</span>
<span class="fc" id="L107">                    factory.ipMap.get(((InetSocketAddress)channel</span>
<span class="fc" id="L108">                            .getRemoteAddress()).getAddress());</span>
<span class="fc" id="L109">                s.remove(this);</span>
<span class="pc" id="L110">            }</span>
<span class="pc" id="L111">        }</span>

<span class="fc bfc" id="L113" title="All 2 branches covered.">        if (channel.isOpen()) {</span>
<span class="fc" id="L114">            channel.close();</span>
        }
<span class="fc" id="L116">        factory.unregisterConnection(this);</span>
<span class="fc" id="L117">    }</span>

    @Override
    public long getSessionId() {
<span class="fc" id="L121">        return sessionId;</span>
    }

    @Override
    public int getSessionTimeout() {
<span class="fc" id="L126">        return sessionTimeout;</span>
    }

    @Override
    public void process(WatchedEvent event) {
<span class="fc" id="L131">        ReplyHeader h = new ReplyHeader(-1, -1L, 0);</span>
<span class="pc bpc" id="L132" title="1 of 2 branches missed.">        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L133">            ZooTrace.logTraceMessage(LOG, ZooTrace.EVENT_DELIVERY_TRACE_MASK,</span>
                                     &quot;Deliver event &quot; + event + &quot; to 0x&quot;
<span class="nc" id="L135">                                     + Long.toHexString(this.sessionId)</span>
                                     + &quot; through &quot; + this);
        }

        // Convert WatchedEvent to a type that can be sent over the wire
<span class="fc" id="L140">        WatcherEvent e = event.getWrapper();</span>

        try {
<span class="fc" id="L143">            sendResponse(h, e, &quot;notification&quot;);</span>
<span class="nc" id="L144">        } catch (IOException e1) {</span>
<span class="nc bnc" id="L145" title="All 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L146">                LOG.debug(&quot;Problem sending to &quot; + getRemoteSocketAddress(), e1);</span>
            }
<span class="nc" id="L148">            close();</span>
<span class="fc" id="L149">        }</span>
<span class="fc" id="L150">    }</span>

<span class="fc" id="L152">    private static final byte[] fourBytes = new byte[4];</span>
    static class ResumeMessageEvent implements MessageEvent {
        Channel channel;
<span class="fc" id="L155">        ResumeMessageEvent(Channel channel) {</span>
<span class="fc" id="L156">            this.channel = channel;</span>
<span class="fc" id="L157">        }</span>
        @Override
<span class="nc" id="L159">        public Object getMessage() {return null;}</span>
        @Override
<span class="nc" id="L161">        public SocketAddress getRemoteAddress() {return null;}</span>
        @Override
<span class="nc" id="L163">        public Channel getChannel() {return channel;}</span>
        @Override
<span class="nc" id="L165">        public ChannelFuture getFuture() {return null;}</span>
    };
    
    @Override
    public void sendResponse(ReplyHeader h, Record r, String tag)
            throws IOException {
<span class="fc bfc" id="L171" title="All 2 branches covered.">        if (!channel.isOpen()) {</span>
<span class="fc" id="L172">            return;</span>
        }
<span class="fc" id="L174">        ByteArrayOutputStream baos = new ByteArrayOutputStream();</span>
        // Make space for length
<span class="fc" id="L176">        BinaryOutputArchive bos = BinaryOutputArchive.getArchive(baos);</span>
        try {
<span class="fc" id="L178">            baos.write(fourBytes);</span>
<span class="fc" id="L179">            bos.writeRecord(h, &quot;header&quot;);</span>
<span class="fc bfc" id="L180" title="All 2 branches covered.">            if (r != null) {</span>
<span class="fc" id="L181">                bos.writeRecord(r, tag);</span>
            }
<span class="fc" id="L183">            baos.close();</span>
<span class="nc" id="L184">        } catch (IOException e) {</span>
<span class="nc" id="L185">            LOG.error(&quot;Error serializing response&quot;);</span>
<span class="fc" id="L186">        }</span>
<span class="fc" id="L187">        byte b[] = baos.toByteArray();</span>
<span class="fc" id="L188">        ByteBuffer bb = ByteBuffer.wrap(b);</span>
<span class="fc" id="L189">        bb.putInt(b.length - 4).rewind();</span>
<span class="fc" id="L190">        sendBuffer(bb);</span>
<span class="fc bfc" id="L191" title="All 2 branches covered.">        if (h.getXid() &gt; 0) {</span>
            // zks cannot be null otherwise we would not have gotten here!
<span class="fc bfc" id="L193" title="All 2 branches covered.">            if (!zkServer.shouldThrottle(outstandingCount.decrementAndGet())) {</span>
<span class="fc" id="L194">                enableRecv();</span>
            }
        }
<span class="fc" id="L197">    }</span>

    @Override
    public void setSessionId(long sessionId) {
<span class="fc" id="L201">        this.sessionId = sessionId;</span>
<span class="fc" id="L202">    }</span>

    @Override
    public void enableRecv() {
<span class="fc bfc" id="L206" title="All 2 branches covered.">        if (throttled) {</span>
<span class="fc" id="L207">            throttled = false;</span>
<span class="pc bpc" id="L208" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L209">                LOG.debug(&quot;Sending unthrottle event &quot; + this);</span>
            }
<span class="fc" id="L211">            channel.getPipeline().sendUpstream(new ResumeMessageEvent(channel));</span>
        }
<span class="fc" id="L213">    }</span>

    @Override
    public void sendBuffer(ByteBuffer sendBuffer) {
<span class="fc bfc" id="L217" title="All 2 branches covered.">        if (sendBuffer == ServerCnxnFactory.closeConn) {</span>
<span class="fc" id="L218">            close();</span>
<span class="fc" id="L219">            return;</span>
        }
<span class="fc" id="L221">        channel.write(wrappedBuffer(sendBuffer));</span>
<span class="fc" id="L222">        packetSent();</span>
<span class="fc" id="L223">    }</span>

    /**
     * clean up the socket related to a command and also make sure we flush the
     * data before we do that
     * 
     * @param pwriter
     *            the pwriter for a command socket
     */
    private void cleanupWriterSocket(PrintWriter pwriter) {
        try {
<span class="pc bpc" id="L234" title="1 of 2 branches missed.">            if (pwriter != null) {</span>
<span class="fc" id="L235">                pwriter.flush();</span>
<span class="fc" id="L236">                pwriter.close();</span>
            }
<span class="pc" id="L238">        } catch (Exception e) {</span>
<span class="nc" id="L239">            LOG.info(&quot;Error closing PrintWriter &quot;, e);</span>
<span class="nc" id="L240">        } finally {</span>
<span class="nc" id="L241">            try {</span>
<span class="pc" id="L242">                close();</span>
<span class="nc" id="L243">            } catch (Exception e) {</span>
<span class="nc" id="L244">                LOG.error(&quot;Error closing a command socket &quot;, e);</span>
<span class="pc" id="L245">            }</span>
<span class="pc" id="L246">        }</span>
<span class="fc" id="L247">    }</span>

    /**
     * This class wraps the sendBuffer method of NIOServerCnxn. It is
     * responsible for chunking up the response to a client. Rather
     * than cons'ing up a response fully in memory, which may be large
     * for some commands, this class chunks up the result.
     */
<span class="fc" id="L255">    private class SendBufferWriter extends Writer {</span>
<span class="fc" id="L256">        private StringBuffer sb = new StringBuffer();</span>
        
        /**
         * Check if we are ready to send another chunk.
         * @param force force sending, even if not a full chunk
         */
        private void checkFlush(boolean force) {
<span class="fc bfc" id="L263" title="All 6 branches covered.">            if ((force &amp;&amp; sb.length() &gt; 0) || sb.length() &gt; 2048) {</span>
<span class="fc" id="L264">                sendBuffer(ByteBuffer.wrap(sb.toString().getBytes()));</span>
                // clear our internal buffer
<span class="fc" id="L266">                sb.setLength(0);</span>
            }
<span class="fc" id="L268">        }</span>

        @Override
        public void close() throws IOException {
<span class="pc bpc" id="L272" title="1 of 2 branches missed.">            if (sb == null) return;</span>
<span class="fc" id="L273">            checkFlush(true);</span>
<span class="fc" id="L274">            sb = null; // clear out the ref to ensure no reuse</span>
<span class="fc" id="L275">        }</span>

        @Override
        public void flush() throws IOException {
<span class="fc" id="L279">            checkFlush(true);</span>
<span class="fc" id="L280">        }</span>

        @Override
        public void write(char[] cbuf, int off, int len) throws IOException {
<span class="fc" id="L284">            sb.append(cbuf, off, len);</span>
<span class="fc" id="L285">            checkFlush(false);</span>
<span class="fc" id="L286">        }</span>
    }

    private static final String ZK_NOT_SERVING =
        &quot;This ZooKeeper instance is not currently serving requests&quot;;
    
    /**
     * Set of threads for commmand ports. All the 4
     * letter commands are run via a thread. Each class
     * maps to a correspoding 4 letter command. CommandThread
     * is the abstract class from which all the others inherit.
     */
    private abstract class CommandThread /*extends Thread*/ {
        PrintWriter pw;
        
<span class="fc" id="L301">        CommandThread(PrintWriter pw) {</span>
<span class="fc" id="L302">            this.pw = pw;</span>
<span class="fc" id="L303">        }</span>
        
        public void start() {
<span class="fc" id="L306">            run();</span>
<span class="fc" id="L307">        }</span>

        public void run() {
            try {
<span class="fc" id="L311">                commandRun();</span>
<span class="pc" id="L312">            } catch (IOException ie) {</span>
<span class="nc" id="L313">                LOG.error(&quot;Error in running command &quot;, ie);</span>
<span class="nc" id="L314">            } finally {</span>
<span class="nc" id="L315">                cleanupWriterSocket(pw);</span>
<span class="pc" id="L316">            }</span>
<span class="pc" id="L317">        }</span>
        
        public abstract void commandRun() throws IOException;
    }
    
    private class RuokCommand extends CommandThread {
<span class="fc" id="L323">        public RuokCommand(PrintWriter pw) {</span>
<span class="fc" id="L324">            super(pw);</span>
<span class="fc" id="L325">        }</span>
        
        @Override
        public void commandRun() {
<span class="fc" id="L329">            pw.print(&quot;imok&quot;);</span>
            
<span class="fc" id="L331">        }</span>
    }
    
    private class TraceMaskCommand extends CommandThread {
<span class="fc" id="L335">        TraceMaskCommand(PrintWriter pw) {</span>
<span class="fc" id="L336">            super(pw);</span>
<span class="fc" id="L337">        }</span>
        
        @Override
        public void commandRun() {
<span class="fc" id="L341">            long traceMask = ZooTrace.getTextTraceLevel();</span>
<span class="fc" id="L342">            pw.print(traceMask);</span>
<span class="fc" id="L343">        }</span>
    }
    
    private class SetTraceMaskCommand extends CommandThread {
<span class="fc" id="L347">        long trace = 0;</span>
<span class="fc" id="L348">        SetTraceMaskCommand(PrintWriter pw, long trace) {</span>
<span class="fc" id="L349">            super(pw);</span>
<span class="fc" id="L350">            this.trace = trace;</span>
<span class="fc" id="L351">        }</span>
        
        @Override
        public void commandRun() {
<span class="fc" id="L355">            pw.print(trace);</span>
<span class="fc" id="L356">        }</span>
    }
    
    private class EnvCommand extends CommandThread {
<span class="fc" id="L360">        EnvCommand(PrintWriter pw) {</span>
<span class="fc" id="L361">            super(pw);</span>
<span class="fc" id="L362">        }</span>
        
        @Override
        public void commandRun() {
<span class="fc" id="L366">            List&lt;Environment.Entry&gt; env = Environment.list();</span>

<span class="fc" id="L368">            pw.println(&quot;Environment:&quot;);</span>
<span class="fc bfc" id="L369" title="All 2 branches covered.">            for(Environment.Entry e : env) {</span>
<span class="fc" id="L370">                pw.print(e.getKey());</span>
<span class="fc" id="L371">                pw.print(&quot;=&quot;);</span>
<span class="fc" id="L372">                pw.println(e.getValue());</span>
<span class="fc" id="L373">            }</span>
            
<span class="fc" id="L375">        } </span>
    }
    
    private class ConfCommand extends CommandThread {
<span class="fc" id="L379">        ConfCommand(PrintWriter pw) {</span>
<span class="fc" id="L380">            super(pw);</span>
<span class="fc" id="L381">        }</span>
            
        @Override
        public void commandRun() {
<span class="pc bpc" id="L385" title="1 of 2 branches missed.">            if (zkServer == null) {</span>
<span class="nc" id="L386">                pw.println(ZK_NOT_SERVING);</span>
            } else {
<span class="fc" id="L388">                zkServer.dumpConf(pw);</span>
            }
<span class="fc" id="L390">        }</span>
    }
    
    private class StatResetCommand extends CommandThread {
<span class="fc" id="L394">        public StatResetCommand(PrintWriter pw) {</span>
<span class="fc" id="L395">            super(pw);</span>
<span class="fc" id="L396">        }</span>
        
        @Override
        public void commandRun() {
<span class="pc bpc" id="L400" title="1 of 2 branches missed.">            if (zkServer == null) {</span>
<span class="nc" id="L401">                pw.println(ZK_NOT_SERVING);</span>
            }
            else { 
<span class="fc" id="L404">                zkServer.serverStats().reset();</span>
<span class="fc" id="L405">                pw.println(&quot;Server stats reset.&quot;);</span>
            }
<span class="fc" id="L407">        }</span>
    }
    
    private class CnxnStatResetCommand extends CommandThread {
<span class="fc" id="L411">        public CnxnStatResetCommand(PrintWriter pw) {</span>
<span class="fc" id="L412">            super(pw);</span>
<span class="fc" id="L413">        }</span>
        
        @Override
        public void commandRun() {
<span class="pc bpc" id="L417" title="1 of 2 branches missed.">            if (zkServer == null) {</span>
<span class="nc" id="L418">                pw.println(ZK_NOT_SERVING);</span>
            } else {
<span class="fc" id="L420">                synchronized(factory.cnxns){</span>
<span class="fc bfc" id="L421" title="All 2 branches covered.">                    for(ServerCnxn c : factory.cnxns){</span>
<span class="fc" id="L422">                        c.resetStats();</span>
<span class="fc" id="L423">                    }</span>
<span class="pc" id="L424">                }</span>
<span class="fc" id="L425">                pw.println(&quot;Connection stats reset.&quot;);</span>
            }
<span class="fc" id="L427">        }</span>
    }

    private class DumpCommand extends CommandThread {
<span class="fc" id="L431">        public DumpCommand(PrintWriter pw) {</span>
<span class="fc" id="L432">            super(pw);</span>
<span class="fc" id="L433">        }</span>
        
        @Override
        public void commandRun() {
<span class="pc bpc" id="L437" title="1 of 2 branches missed.">            if (zkServer == null) {</span>
<span class="nc" id="L438">                pw.println(ZK_NOT_SERVING);</span>
            }
            else {
<span class="fc" id="L441">                pw.println(&quot;SessionTracker dump:&quot;);</span>
<span class="fc" id="L442">                zkServer.sessionTracker.dumpSessions(pw);</span>
<span class="fc" id="L443">                pw.println(&quot;ephemeral nodes dump:&quot;);</span>
<span class="fc" id="L444">                zkServer.dumpEphemerals(pw);</span>
            }
<span class="fc" id="L446">        }</span>
    }
    
    private class StatCommand extends CommandThread {
        int len;
<span class="fc" id="L451">        public StatCommand(PrintWriter pw, int len) {</span>
<span class="fc" id="L452">            super(pw);</span>
<span class="fc" id="L453">            this.len = len;</span>
<span class="fc" id="L454">        }</span>
        
        @Override
        public void commandRun() {
<span class="fc bfc" id="L458" title="All 2 branches covered.">            if (zkServer == null) {</span>
<span class="fc" id="L459">                pw.println(ZK_NOT_SERVING);</span>
            }
            else {   
<span class="fc" id="L462">                pw.print(&quot;Zookeeper version: &quot;);</span>
<span class="fc" id="L463">                pw.println(Version.getFullVersion());</span>
<span class="pc bpc" id="L464" title="1 of 2 branches missed.">                if (zkServer instanceof ReadOnlyZooKeeperServer) {</span>
<span class="nc" id="L465">                    pw.println(&quot;READ-ONLY mode; serving only &quot; +</span>
                               &quot;read-only clients&quot;);
                }
<span class="fc bfc" id="L468" title="All 2 branches covered.">                if (len == statCmd) {</span>
<span class="fc" id="L469">                    LOG.info(&quot;Stat command output&quot;);</span>
<span class="fc" id="L470">                    pw.println(&quot;Clients:&quot;);</span>
                    // clone should be faster than iteration
                    // ie give up the cnxns lock faster
                    HashSet&lt;ServerCnxn&gt; cnxns;
<span class="fc" id="L474">                    synchronized(factory.cnxns){</span>
<span class="fc" id="L475">                        cnxns = new HashSet&lt;ServerCnxn&gt;(factory.cnxns);</span>
<span class="pc" id="L476">                    }</span>
<span class="fc bfc" id="L477" title="All 2 branches covered.">                    for(ServerCnxn c : cnxns){</span>
<span class="fc" id="L478">                        c.dumpConnectionInfo(pw, true);</span>
<span class="fc" id="L479">                        pw.println();</span>
<span class="fc" id="L480">                    }</span>
<span class="fc" id="L481">                    pw.println();</span>
                }
<span class="fc" id="L483">                pw.print(zkServer.serverStats().toString());</span>
<span class="fc" id="L484">                pw.print(&quot;Node count: &quot;);</span>
<span class="fc" id="L485">                pw.println(zkServer.getZKDatabase().getNodeCount());</span>
            }
            
<span class="fc" id="L488">        }</span>
    }
    
    private class ConsCommand extends CommandThread {
<span class="fc" id="L492">        public ConsCommand(PrintWriter pw) {</span>
<span class="fc" id="L493">            super(pw);</span>
<span class="fc" id="L494">        }</span>
        
        @Override
        public void commandRun() {
<span class="pc bpc" id="L498" title="1 of 2 branches missed.">            if (zkServer == null) {</span>
<span class="nc" id="L499">                pw.println(ZK_NOT_SERVING);</span>
            } else {
                // clone should be faster than iteration
                // ie give up the cnxns lock faster
                AbstractSet&lt;ServerCnxn&gt; cnxns;
<span class="fc" id="L504">                synchronized (factory.cnxns) {</span>
<span class="fc" id="L505">                    cnxns = new HashSet&lt;ServerCnxn&gt;(factory.cnxns);</span>
<span class="pc" id="L506">                }</span>
<span class="fc bfc" id="L507" title="All 2 branches covered.">                for (ServerCnxn c : cnxns) {</span>
<span class="fc" id="L508">                    c.dumpConnectionInfo(pw, false);</span>
<span class="fc" id="L509">                    pw.println();</span>
<span class="fc" id="L510">                }</span>
<span class="fc" id="L511">                pw.println();</span>
            }
<span class="fc" id="L513">        }</span>
    }
    
    private class WatchCommand extends CommandThread {
<span class="fc" id="L517">        int len = 0;</span>
<span class="fc" id="L518">        public WatchCommand(PrintWriter pw, int len) {</span>
<span class="fc" id="L519">            super(pw);</span>
<span class="fc" id="L520">            this.len = len;</span>
<span class="fc" id="L521">        }</span>

        @Override
        public void commandRun() {
<span class="pc bpc" id="L525" title="1 of 2 branches missed.">            if (zkServer == null) {</span>
<span class="nc" id="L526">                pw.println(ZK_NOT_SERVING);</span>
            } else {
<span class="fc" id="L528">                DataTree dt = zkServer.getZKDatabase().getDataTree();</span>
<span class="fc bfc" id="L529" title="All 2 branches covered.">                if (len == wchsCmd) {</span>
<span class="fc" id="L530">                    dt.dumpWatchesSummary(pw);</span>
<span class="fc bfc" id="L531" title="All 2 branches covered.">                } else if (len == wchpCmd) {</span>
<span class="fc" id="L532">                    dt.dumpWatches(pw, true);</span>
                } else {
<span class="fc" id="L534">                    dt.dumpWatches(pw, false);</span>
                }
<span class="fc" id="L536">                pw.println();</span>
            }
<span class="fc" id="L538">        }</span>
    }

    private class MonitorCommand extends CommandThread {

<span class="fc" id="L543">        MonitorCommand(PrintWriter pw) {</span>
<span class="fc" id="L544">            super(pw);</span>
<span class="fc" id="L545">        }</span>

        @Override
        public void commandRun() {
<span class="pc bpc" id="L549" title="1 of 2 branches missed.">            if(zkServer == null) {</span>
<span class="nc" id="L550">                pw.println(ZK_NOT_SERVING);</span>
<span class="nc" id="L551">                return;</span>
            }
<span class="fc" id="L553">            ZKDatabase zkdb = zkServer.getZKDatabase();</span>
<span class="fc" id="L554">            ServerStats stats = zkServer.serverStats();</span>

<span class="fc" id="L556">            print(&quot;version&quot;, Version.getFullVersion());</span>

<span class="fc" id="L558">            print(&quot;avg_latency&quot;, stats.getAvgLatency());</span>
<span class="fc" id="L559">            print(&quot;max_latency&quot;, stats.getMaxLatency());</span>
<span class="fc" id="L560">            print(&quot;min_latency&quot;, stats.getMinLatency());</span>

<span class="fc" id="L562">            print(&quot;packets_received&quot;, stats.getPacketsReceived());</span>
<span class="fc" id="L563">            print(&quot;packets_sent&quot;, stats.getPacketsSent());</span>
<span class="fc" id="L564">            print(&quot;num_alive_connections&quot;, stats.getNumAliveClientConnections());</span>

<span class="fc" id="L566">            print(&quot;outstanding_requests&quot;, stats.getOutstandingRequests());</span>

<span class="fc" id="L568">            print(&quot;server_state&quot;, stats.getServerState());</span>
<span class="fc" id="L569">            print(&quot;znode_count&quot;, zkdb.getNodeCount());</span>

<span class="fc" id="L571">            print(&quot;watch_count&quot;, zkdb.getDataTree().getWatchCount());</span>
<span class="fc" id="L572">            print(&quot;ephemerals_count&quot;, zkdb.getDataTree().getEphemeralsCount());</span>
<span class="fc" id="L573">            print(&quot;approximate_data_size&quot;, zkdb.getDataTree().approximateDataSize());</span>

<span class="fc" id="L575">            OSMXBean osMbean = new OSMXBean();</span>
<span class="pc bpc" id="L576" title="2 of 4 branches missed.">            if (osMbean != null &amp;&amp; osMbean.getUnix() == true) {</span>
<span class="fc" id="L577">                print(&quot;open_file_descriptor_count&quot;, osMbean.getOpenFileDescriptorCount());</span>
<span class="fc" id="L578">                print(&quot;max_file_descriptor_count&quot;, osMbean.getMaxFileDescriptorCount());</span>
            }
          
<span class="pc bpc" id="L581" title="1 of 2 branches missed.">            if(stats.getServerState().equals(&quot;leader&quot;)) {</span>
<span class="nc" id="L582">                Leader leader = ((LeaderZooKeeperServer)zkServer).getLeader();</span>

<span class="nc" id="L584">                print(&quot;followers&quot;, leader.getLearners().size());</span>
<span class="nc" id="L585">                print(&quot;synced_followers&quot;, leader.getForwardingFollowers().size());</span>
<span class="nc" id="L586">                print(&quot;pending_syncs&quot;, leader.getNumPendingSyncs());</span>
            }
<span class="fc" id="L588">        }</span>

        private void print(String key, long number) {
<span class="fc" id="L591">            print(key, &quot;&quot; + number);</span>
<span class="fc" id="L592">        }</span>

        private void print(String key, String value) {
<span class="fc" id="L595">            pw.print(&quot;zk_&quot;);</span>
<span class="fc" id="L596">            pw.print(key);</span>
<span class="fc" id="L597">            pw.print(&quot;\t&quot;);</span>
<span class="fc" id="L598">            pw.println(value);</span>
<span class="fc" id="L599">        }</span>

    }

    private class IsroCommand extends CommandThread {

<span class="fc" id="L605">        public IsroCommand(PrintWriter pw) {</span>
<span class="fc" id="L606">            super(pw);</span>
<span class="fc" id="L607">        }</span>

        @Override
        public void commandRun() {
<span class="pc bpc" id="L611" title="1 of 2 branches missed.">            if (zkServer == null) {</span>
<span class="nc" id="L612">                pw.print(&quot;null&quot;);</span>
<span class="pc bpc" id="L613" title="1 of 2 branches missed.">            } else if (zkServer instanceof ReadOnlyZooKeeperServer) {</span>
<span class="nc" id="L614">                pw.print(&quot;ro&quot;);</span>
            } else {
<span class="fc" id="L616">                pw.print(&quot;rw&quot;);</span>
            }
<span class="fc" id="L618">        }</span>
    }

    /** Return if four letter word found and responded to, otw false **/
    private boolean checkFourLetterWord(final Channel channel,
            ChannelBuffer message, final int len) throws IOException
    {
        // We take advantage of the limited size of the length to look
        // for cmds. They are all 4-bytes which fits inside of an int
<span class="fc" id="L627">        String cmd = cmd2String.get(len);</span>
<span class="fc bfc" id="L628" title="All 2 branches covered.">        if (cmd == null) {</span>
<span class="fc" id="L629">            return false;</span>
        }
<span class="fc" id="L631">        channel.setInterestOps(0).awaitUninterruptibly();</span>
<span class="fc" id="L632">        LOG.info(&quot;Processing &quot; + cmd + &quot; command from &quot;</span>
<span class="fc" id="L633">                + channel.getRemoteAddress());</span>
<span class="fc" id="L634">        packetReceived();</span>

<span class="fc" id="L636">        final PrintWriter pwriter = new PrintWriter(</span>
                new BufferedWriter(new SendBufferWriter()));
<span class="fc bfc" id="L638" title="All 2 branches covered.">        if (len == ruokCmd) {</span>
<span class="fc" id="L639">            RuokCommand ruok = new RuokCommand(pwriter);</span>
<span class="fc" id="L640">            ruok.start();</span>
<span class="fc" id="L641">            return true;</span>
<span class="fc bfc" id="L642" title="All 2 branches covered.">        } else if (len == getTraceMaskCmd) {</span>
<span class="fc" id="L643">            TraceMaskCommand tmask = new TraceMaskCommand(pwriter);</span>
<span class="fc" id="L644">            tmask.start();</span>
<span class="fc" id="L645">            return true;</span>
<span class="fc bfc" id="L646" title="All 2 branches covered.">        } else if (len == setTraceMaskCmd) {</span>
<span class="fc" id="L647">            ByteBuffer mask = ByteBuffer.allocate(8);</span>
<span class="fc" id="L648">            message.readBytes(mask);</span>
<span class="fc" id="L649">            mask.flip();</span>
<span class="fc" id="L650">            long traceMask = mask.getLong();</span>
<span class="fc" id="L651">            ZooTrace.setTextTraceLevel(traceMask);</span>
<span class="fc" id="L652">            SetTraceMaskCommand setMask = new SetTraceMaskCommand(pwriter, traceMask);</span>
<span class="fc" id="L653">            setMask.start();</span>
<span class="fc" id="L654">            return true;</span>
<span class="fc bfc" id="L655" title="All 2 branches covered.">        } else if (len == enviCmd) {</span>
<span class="fc" id="L656">            EnvCommand env = new EnvCommand(pwriter);</span>
<span class="fc" id="L657">            env.start();</span>
<span class="fc" id="L658">            return true;</span>
<span class="fc bfc" id="L659" title="All 2 branches covered.">        } else if (len == confCmd) {</span>
<span class="fc" id="L660">            ConfCommand ccmd = new ConfCommand(pwriter);</span>
<span class="fc" id="L661">            ccmd.start();</span>
<span class="fc" id="L662">            return true;</span>
<span class="fc bfc" id="L663" title="All 2 branches covered.">        } else if (len == srstCmd) {</span>
<span class="fc" id="L664">            StatResetCommand strst = new StatResetCommand(pwriter);</span>
<span class="fc" id="L665">            strst.start();</span>
<span class="fc" id="L666">            return true;</span>
<span class="fc bfc" id="L667" title="All 2 branches covered.">        } else if (len == crstCmd) {</span>
<span class="fc" id="L668">            CnxnStatResetCommand crst = new CnxnStatResetCommand(pwriter);</span>
<span class="fc" id="L669">            crst.start();</span>
<span class="fc" id="L670">            return true;</span>
<span class="fc bfc" id="L671" title="All 2 branches covered.">        } else if (len == dumpCmd) {</span>
<span class="fc" id="L672">            DumpCommand dump = new DumpCommand(pwriter);</span>
<span class="fc" id="L673">            dump.start();</span>
<span class="fc" id="L674">            return true;</span>
<span class="fc bfc" id="L675" title="All 4 branches covered.">        } else if (len == statCmd || len == srvrCmd) {</span>
<span class="fc" id="L676">            StatCommand stat = new StatCommand(pwriter, len);</span>
<span class="fc" id="L677">            stat.start();</span>
<span class="fc" id="L678">            return true;</span>
<span class="fc bfc" id="L679" title="All 2 branches covered.">        } else if (len == consCmd) {</span>
<span class="fc" id="L680">            ConsCommand cons = new ConsCommand(pwriter);</span>
<span class="fc" id="L681">            cons.start();</span>
<span class="fc" id="L682">            return true;</span>
<span class="fc bfc" id="L683" title="All 6 branches covered.">        } else if (len == wchpCmd || len == wchcCmd || len == wchsCmd) {</span>
<span class="fc" id="L684">            WatchCommand wcmd = new WatchCommand(pwriter, len);</span>
<span class="fc" id="L685">            wcmd.start();</span>
<span class="fc" id="L686">            return true;</span>
<span class="fc bfc" id="L687" title="All 2 branches covered.">        } else if (len == mntrCmd) {</span>
<span class="fc" id="L688">            MonitorCommand mntr = new MonitorCommand(pwriter);</span>
<span class="fc" id="L689">            mntr.start();</span>
<span class="fc" id="L690">            return true;</span>
<span class="pc bpc" id="L691" title="1 of 2 branches missed.">        } else if (len == isroCmd) {</span>
<span class="fc" id="L692">            IsroCommand isro = new IsroCommand(pwriter);</span>
<span class="fc" id="L693">            isro.start();</span>
<span class="fc" id="L694">            return true;</span>
        }
<span class="nc" id="L696">        return false;</span>
    }

    public void receiveMessage(ChannelBuffer message) {
        try {
<span class="fc bfc" id="L701" title="All 4 branches covered.">            while(message.readable() &amp;&amp; !throttled) {</span>
<span class="fc bfc" id="L702" title="All 2 branches covered.">                if (bb != null) {</span>
<span class="pc bpc" id="L703" title="1 of 2 branches missed.">                    if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L704">                        LOG.trace(&quot;message readable &quot; + message.readableBytes()</span>
<span class="nc" id="L705">                                + &quot; bb len &quot; + bb.remaining() + &quot; &quot; + bb);</span>
<span class="nc" id="L706">                        ByteBuffer dat = bb.duplicate();</span>
<span class="nc" id="L707">                        dat.flip();</span>
<span class="nc" id="L708">                        LOG.trace(Long.toHexString(sessionId)</span>
                                + &quot; bb 0x&quot;
<span class="nc" id="L710">                                + ChannelBuffers.hexDump(</span>
<span class="nc" id="L711">                                        ChannelBuffers.copiedBuffer(dat)));</span>
                    }

<span class="fc bfc" id="L714" title="All 2 branches covered.">                    if (bb.remaining() &gt; message.readableBytes()) {</span>
<span class="fc" id="L715">                        int newLimit = bb.position() + message.readableBytes();</span>
<span class="fc" id="L716">                        bb.limit(newLimit);</span>
                    }
<span class="fc" id="L718">                    message.readBytes(bb);</span>
<span class="fc" id="L719">                    bb.limit(bb.capacity());</span>

<span class="pc bpc" id="L721" title="1 of 2 branches missed.">                    if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L722">                        LOG.trace(&quot;after readBytes message readable &quot;</span>
<span class="nc" id="L723">                                + message.readableBytes()</span>
<span class="nc" id="L724">                                + &quot; bb len &quot; + bb.remaining() + &quot; &quot; + bb);</span>
<span class="nc" id="L725">                        ByteBuffer dat = bb.duplicate();</span>
<span class="nc" id="L726">                        dat.flip();</span>
<span class="nc" id="L727">                        LOG.trace(&quot;after readbytes &quot;</span>
<span class="nc" id="L728">                                + Long.toHexString(sessionId)</span>
                                + &quot; bb 0x&quot;
<span class="nc" id="L730">                                + ChannelBuffers.hexDump(</span>
<span class="nc" id="L731">                                        ChannelBuffers.copiedBuffer(dat)));</span>
                    }
<span class="fc bfc" id="L733" title="All 2 branches covered.">                    if (bb.remaining() == 0) {</span>
<span class="fc" id="L734">                        packetReceived();</span>
<span class="fc" id="L735">                        bb.flip();</span>

<span class="fc" id="L737">                        ZooKeeperServer zks = this.zkServer;</span>
<span class="pc bpc" id="L738" title="1 of 2 branches missed.">                        if (zks == null) {</span>
<span class="nc" id="L739">                            throw new IOException(&quot;ZK down&quot;);</span>
                        }
<span class="fc bfc" id="L741" title="All 2 branches covered.">                        if (initialized) {</span>
<span class="fc" id="L742">                            zks.processPacket(this, bb);</span>

<span class="fc bfc" id="L744" title="All 2 branches covered.">                            if (zks.shouldThrottle(outstandingCount.incrementAndGet())) {</span>
<span class="fc" id="L745">                                disableRecvNoWait();</span>
                            }
                        } else {
<span class="fc" id="L748">                            LOG.debug(&quot;got conn req request from &quot;</span>
<span class="fc" id="L749">                                    + getRemoteSocketAddress());</span>
<span class="fc" id="L750">                            zks.processConnectRequest(this, bb);</span>
<span class="fc" id="L751">                            initialized = true;</span>
                        }
<span class="fc" id="L753">                        bb = null;</span>
<span class="fc" id="L754">                    }</span>
                } else {
<span class="pc bpc" id="L756" title="1 of 2 branches missed.">                    if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L757">                        LOG.trace(&quot;message readable &quot;</span>
<span class="nc" id="L758">                                + message.readableBytes()</span>
<span class="nc" id="L759">                                + &quot; bblenrem &quot; + bbLen.remaining());</span>
<span class="nc" id="L760">                        ByteBuffer dat = bbLen.duplicate();</span>
<span class="nc" id="L761">                        dat.flip();</span>
<span class="nc" id="L762">                        LOG.trace(Long.toHexString(sessionId)</span>
                                + &quot; bbLen 0x&quot;
<span class="nc" id="L764">                                + ChannelBuffers.hexDump(</span>
<span class="nc" id="L765">                                        ChannelBuffers.copiedBuffer(dat)));</span>
                    }

<span class="fc bfc" id="L768" title="All 2 branches covered.">                    if (message.readableBytes() &lt; bbLen.remaining()) {</span>
<span class="fc" id="L769">                        bbLen.limit(bbLen.position() + message.readableBytes());</span>
                    }
<span class="fc" id="L771">                    message.readBytes(bbLen);</span>
<span class="fc" id="L772">                    bbLen.limit(bbLen.capacity());</span>
<span class="fc bfc" id="L773" title="All 2 branches covered.">                    if (bbLen.remaining() == 0) {</span>
<span class="fc" id="L774">                        bbLen.flip();</span>

<span class="pc bpc" id="L776" title="1 of 2 branches missed.">                        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L777">                            LOG.trace(Long.toHexString(sessionId)</span>
                                    + &quot; bbLen 0x&quot;
<span class="nc" id="L779">                                    + ChannelBuffers.hexDump(</span>
<span class="nc" id="L780">                                            ChannelBuffers.copiedBuffer(bbLen)));</span>
                        }
<span class="fc" id="L782">                        int len = bbLen.getInt();</span>
<span class="pc bpc" id="L783" title="1 of 2 branches missed.">                        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L784">                            LOG.trace(Long.toHexString(sessionId)</span>
                                    + &quot; bbLen len is &quot; + len);
                        }

<span class="fc" id="L788">                        bbLen.clear();</span>
<span class="fc bfc" id="L789" title="All 2 branches covered.">                        if (!initialized) {</span>
<span class="fc bfc" id="L790" title="All 2 branches covered.">                            if (checkFourLetterWord(channel, message, len)) {</span>
<span class="fc" id="L791">                                return;</span>
                            }
                        }
<span class="pc bpc" id="L794" title="2 of 4 branches missed.">                        if (len &lt; 0 || len &gt; BinaryInputArchive.maxBuffer) {</span>
<span class="nc" id="L795">                            throw new IOException(&quot;Len error &quot; + len);</span>
                        }
<span class="fc" id="L797">                        bb = ByteBuffer.allocate(len);</span>
<span class="fc" id="L798">                    }</span>
                }
            }
<span class="nc" id="L801">        } catch(IOException e) {</span>
<span class="nc" id="L802">            LOG.warn(&quot;Closing connection to &quot; + getRemoteSocketAddress(), e);</span>
<span class="nc" id="L803">            close();</span>
<span class="fc" id="L804">        }</span>
<span class="fc" id="L805">    }</span>

    @Override
    public void disableRecv() {
<span class="fc" id="L809">        disableRecvNoWait().awaitUninterruptibly();</span>
<span class="fc" id="L810">    }</span>
    
    private ChannelFuture disableRecvNoWait() {
<span class="fc" id="L813">        throttled = true;</span>
<span class="pc bpc" id="L814" title="1 of 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L815">            LOG.debug(&quot;Throttling - disabling recv &quot; + this);</span>
        }
<span class="fc" id="L817">        return channel.setReadable(false);</span>
    }
    
    @Override
    public long getOutstandingRequests() {
<span class="fc" id="L822">        return outstandingCount.longValue();</span>
    }

    @Override
    public void setSessionTimeout(int sessionTimeout) {
<span class="fc" id="L827">        this.sessionTimeout = sessionTimeout;</span>
<span class="fc" id="L828">    }</span>

    @Override
    public int getInterestOps() {
<span class="fc" id="L832">        return channel.getInterestOps();</span>
    }

    @Override
    public InetSocketAddress getRemoteSocketAddress() {
<span class="fc" id="L837">        return (InetSocketAddress)channel.getRemoteAddress();</span>
    }

    /** Send close connection packet to the client.
     */
    @Override
    public void sendCloseSession() {
<span class="fc" id="L844">        sendBuffer(ServerCnxnFactory.closeConn);</span>
<span class="fc" id="L845">    }</span>

    @Override
    protected ServerStats serverStats() {
<span class="fc bfc" id="L849" title="All 2 branches covered.">        if (zkServer == null) {</span>
<span class="fc" id="L850">            return null;</span>
        }
<span class="fc" id="L852">        return zkServer.serverStats();</span>
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>